Page MenuHomePhabricator

Make Media Viewer pluggable for the 3d extension, videos, …
Closed, ResolvedPublic

Description

I will try to keep the changes to Media Viewer as minimal as possible and make it so that future "Media Viewer plugins" can benefit from the same integration mechanism.

Details

Related Gerrit Patches:
mediawiki/extensions/MultimediaViewer : masterMake Media Viewer pluggable for the 3D extension

Related Objects

Event Timeline

Gilles created this task.Apr 7 2016, 3:56 PM
Restricted Application added subscribers: Matanya, Aklapper. · View Herald TranscriptApr 7 2016, 3:57 PM
Gilles added a project: 3D.Apr 7 2016, 5:20 PM

Change 282211 had a related patch set uploaded (by Gilles):
Make Media Viewer pluggable for the 3D extension

https://gerrit.wikimedia.org/r/282211

Gilles renamed this task from Make Media Viewer pluggable for the 3D extension to Make Media Viewer pluggable for the 3d extension.Apr 7 2016, 8:28 PM

Can we also explore getting this on mobile web?

Can we also explore getting this on mobile web?

Sure, why not, but I don't really have bandwidth to spare to implement that myself right now. I'm going to carry what I've done so far to try to get it to production, but someone else should pick this up for further functionality development. On mobile the experience at the moment will be the fallback one: just seeing the model converted to an image.

It should be pretty straightforward to get the webgl stuff to work on mobile, but the challenge will be with the UX (how will the controls work, and you'll probably want it to require pressing something to activate the 3d mode, given that some models are very large).

I'm happy to give pointers to anyone who wants to get this working on mobile. IMHO this is a couple of weeks of work at most, mostly UX/UI design to get the experience right. For instance the mobile lightbox relies on progressive loading to indicate loading progress. Here you probably want a progress bar of some kind, as the 3d model can't be progressively displayed and the loading time could be quite long (some of my test models that were scanned, like the statue of David, were 40ish MB - probably a lot less gzipped, but still).

Right now I was just curious if it was theoretically possible.

I'm gonna take a dive into your code. In mean time, please add me to all the multimedia viewer patches so I can learn through review.

I think it is, many mobile browsers seem to support WebGL. I don't know about rendering performance, though, and that will largely depend on what kind of 3d models people upload.

brion added a subscriber: brion.Apr 14 2016, 8:46 PM
brion added a comment.Apr 14 2016, 8:58 PM

@Jdlrobson WebGL does indeed work in iOS Safari, Android Chrome, and some others, though performance will vary a lot depending on device. In general a model viewer should be ok; it doesn't require a high frame rate so it's ok if it slows down a bit on complex models.

Main things for porting:

  • have a good small-screen UX making use of touch controls
  • ideally, be able to use the same plugin setup on the mobile version of the photo viewer overlay as on the desktop one

More generally we should think about whether we want to replace the separate media popup system on mobile with the MMV framework, or just have a plugin system that can extend both.

And then secondarily, decide how to handle things that might show "fancy stuff" inline instead of just an <img> thumbnail, like autoplaying videos or interactive widgets, that we still would like to be able to zoom up in the viewer. Would love to replace animated GIFs with real video compression and have them "just work"!

Jdlrobson changed the status of subtask T132713: Media Viewer browser tests fail from Open to Stalled.Apr 20 2016, 8:43 PM
Jdforrester-WMF renamed this task from Make Media Viewer pluggable for the 3d extension to Make Media Viewer pluggable for the 3d extension, videos, ….Apr 22 2016, 8:09 PM
Jdforrester-WMF moved this task from Untriaged to Doing on the Multimedia board.May 2 2016, 4:17 PM
Jdforrester-WMF removed a project: Multimedia.

Change 282211 merged by jenkins-bot:
Make Media Viewer pluggable for the 3D extension

https://gerrit.wikimedia.org/r/282211

Jdforrester-WMF closed this task as Resolved.May 9 2016, 8:16 PM
Jdforrester-WMF removed a project: Patch-For-Review.